<?php
class ModelExtensionModuleSmsRangine extends Model {
	

    /**
     *
     */
    public function SmsRangine_order_checkbox($css_class_left = "col-sm-2", $css_class_right = "col-sm-10") {

        $this->load->language('extension/module/smsrangine');
        $data['smsrangine_entry_notify_by_sms_label'] = $this->language->get('smsrangine_entry_notify_by_sms_label');

         $data['css_class_left']  = $css_class_left;
         $data['css_class_right'] = $css_class_right;
		return $this->load->view('extension/module/smsrangine_orderinfo_checkbox', $data);
    }

	
    /**
     *
     */
    public function build_request_params_in_order_status_update_ajax_request(){

        /*
         *  + '&notify_by_sms=' + ($('input[name=\'notify_by_sms\']').prop('checked') ? 1 : 0) + '&notify=' +
         */
        $params = "'&notify_by_sms=' + ($('input[name=\'notify_by_sms\']').prop('checked') ? 1 : 0)" ;

        return $params;
    }
	
	public function addTemplate($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "smsrangine_template SET store_id = '" . (int)$data['store_id'] . "', type = '" . $this->db->escape($data['type']) . "', name = '" . $this->db->escape($data['name']) . "', bcc = '" . $this->db->escape($data['bcc']) . "'");
		
		$template_id = $this->db->getLastId();
		
		foreach ($data['description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "smsrangine_template_message SET sms_template_id = '" . (int)$template_id . "', language_id = '" . (int)$language_id . "', message = '" . $this->db->escape($value['message']) . "'");
		}
	}
	
	public function editTemplate($template_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "smsrangine_template SET store_id = '" . (int)$data['store_id'] . "', type = '" . $this->db->escape($data['type']) . "', name = '" . $this->db->escape($data['name']) . "', bcc = '" . $this->db->escape($data['bcc']) . "' WHERE sms_template_id = '" . (int)$template_id . "'");
		
		$this->db->query("DELETE FROM " . DB_PREFIX . "smsrangine_template_message WHERE sms_template_id = '" . (int)$template_id . "'");
		
		foreach ($data['description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "smsrangine_template_message SET sms_template_id = '" . (int)$template_id . "', language_id = '" . (int)$language_id . "', message = '" . $this->db->escape($value['message']) . "'");
		}
	}
	
	public function deleteTemplate($template_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "smsrangine_template WHERE sms_template_id = '" . (int)$template_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "smsrangine_template_message WHERE sms_template_id = '" . (int)$template_id . "'");
	}
	
	public function getTemplate($template_id) { 
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsrangine_template WHERE sms_template_id = '" . (int)$template_id . "'");
		
		if ($query->num_rows) {
			$description = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsrangine_template_message WHERE sms_template_id = '" . (int)$template_id . "'");
			
			$description_data = array();
			
			foreach ($description->rows as $description) {
				$description_data[$description['language_id']] = array(
					'message'		=> $description['message']
				);
			}
			
			return array(
				'sms_template_id'	=> $query->row['sms_template_id'],
				'type'				=> $query->row['type'],
				'store_id'			=> $query->row['store_id'],
				'name'				=> $query->row['name'],
				'bcc'				=> $query->row['bcc'],
				'description'		=> $description_data
			);
		} else {
			return false;
		}
	}
		
	public function getTemplates($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "smsrangine_template";
		
		$sort_data = array(
			'name',
			'type'
		);	
		
		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];	
		} else {
			$sql .= " ORDER BY name";	
		}
		
		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}
		
		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}					

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}	
		
			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}		
		
		$query = $this->db->query($sql);

		return $query->rows;
	}
		
	public function getTotalTemplates() {
      	$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "smsrangine_template");
		
		return $query->row['total'];
	}
	
	private function getSMSTemplates($type, $store_id) { 
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsrangine_template st LEFT JOIN " . DB_PREFIX . "smsrangine_template_message stm ON st.sms_template_id = stm.sms_template_id WHERE type = '" . $this->db->escape($type) . "' AND store_id = '" . (int)$store_id . "' AND language_id = '" . (int)$this->config->get('config_language_id') . "'");
		
		return $query->rows;
	}
	
	private function getSearch($type) {
		if ($type == 'register') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{commission}',
				'{total_commission}'
			);
		} elseif ($type == 'affiliate_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'forgotten') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{password}'
			);
		} elseif ($type == 'order') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		} elseif ($type == 'reward') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{points}',
				'{total_points}'
			);
		} elseif ($type == 'account_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'account_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{credits}',
				'{total_credits}'
			);
		} else {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		}
	
		return $search;
	}
	
	public function parseSMS($type, $store_id, $number, $replace) {
		$number = preg_replace('/[^0-9]/', '', $number);
		if($type == 'send_sms'){
			$this->sendSMS($number, $replace);
		}else{
			$templates = $this->getSMSTemplates($type, $store_id);
			$template_data = false;
			
			$template_data = false;
			foreach ($templates as $template) {
				$template_data = $template;
			}
		
			if ($template_data && !empty($template_data['message'])) {
				$search = $this->getSearch($type);
				
				$message = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['message'])));
				
				$this->sendSMS($number, $message);
				
				$numbers = explode(',', $template_data['bcc']);

				foreach ($numbers as $number) {
					if ($number) {
						$this->sendSMS($number, $message);
					}
				}
			} else {
				return false;
			}
		}
	}
	
	public function sendSMS($receiver = null, $message = null) {
		$response = false;
		$username = trim($this->config->get('smsrangine_username'));
		$password = trim($this->config->get('smsrangine_password'));
		$from     = trim($this->config->get('smsrangine_default_from'));
		$debug    = $this->config->get('smsrangine_debug');
		$massage  = str_replace(array('https://','http://','www.'), array('','',''), $message);
		if($debug == 1){
			$result = "SMS DEBUG(admin): Reciver: {$receiver} - message : {$massage}";
			error_log($result);
			$this->log->write($result);
			$this->session->data['success'] = $result;
			return $result;
		}
		if ( empty( $username ) || empty( $password ) || empty( $from ) ||  empty( $receiver ) ||  empty( $massage ) ) {
			return $response;
		}

		$massage  = strip_tags($massage);
		if(!is_array($receiver)) $to = array($receiver); else $to = $receiver;

		if (substr( $massage, 0, 11 ) === "patterncode"){
		    $massage = str_replace("\r\n",';',$massage);
		    $massage = str_replace("\n",';',$massage);
			$splited = explode(';', $massage);
			$patterncodeArray = explode(':', $splited[0]);
			$patterncode = $patterncodeArray[1];
			unset($splited[0]);
			$input_data = array();
			foreach($splited as $parm){
			  $splited_parm = explode(':', $parm);
			  $input_data[$splited_parm[0]] = $splited_parm[1];
			}
			$url = "http://sms.rangine.ir/patterns/pattern?username=".$username."&password=".urlencode($password)."&from=$from&to=".json_encode($to)."&input_data=".urlencode(json_encode($input_data))."&pattern_code=$patterncode";
			//error_log($url);
			$handler = curl_init($url);             
			curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "GET");
			curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
			$result = curl_exec($handler);

			if ( ! empty( $result ) && is_numeric( $result ) ) {
				$response = true;
			} else {
			    error_log($result);
			}

			return $response;
		}else{
			$url = "sms.rangine.ir/services.jspd";
			$param = array
						(
							'uname'=>$username,
							'pass'=>$password,
							'from'=>$from,
							'message'=>$massage,
							'to'=>json_encode($to),
							'op'=>'send'
						);

			$handler = curl_init($url);             
			curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "POST");
			curl_setopt($handler, CURLOPT_POSTFIELDS, $param);                       
			curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
			$result = curl_exec($handler);
			
			$result2 = json_decode($result);
			$res_code = $result2[0];
			$res_data = $result2[1];
			if ($res_code == '0'){
				$response = true;
			} else {
			    error_log($result);
			}
			return $response;
		}
	}
}
